function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/* Copyright (c) 2015-present, salesforce.com, inc. All rights reserved */

/* Licensed under BSD 3-Clause - see LICENSE.txt or git.io/sfdc-license */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames'; // ## Constants

import { PAGE_HEADER_CONTROL } from '../../../utilities/constants';
var displayName = 'PageHeaderControls';
var propTypes = {
  /**
   * Optional class name
   */
  className: PropTypes.oneOfType([PropTypes.array, PropTypes.object, PropTypes.string]),

  /**
   * Type of this controls component ('actions' or 'controls')
   */
  type: PropTypes.oneOf(['actions', 'controls'])
};
var defaultProps = {};

var Controls =
/*#__PURE__*/
function (_Component) {
  _inherits(Controls, _Component);

  function Controls() {
    _classCallCheck(this, Controls);

    return _possibleConstructorReturn(this, _getPrototypeOf(Controls).apply(this, arguments));
  }

  _createClass(Controls, [{
    key: "render",
    value: function render() {
      var controls;
      var isUsingLegacyProp;
      var legacyControls;
      var vettedControls;

      if (this.props.type === 'actions') {
        if (this.props.onRenderActions) {
          controls = this.props.onRenderActions();
        } else if (this.props.contentRight) {
          controls = this.props.contentRight;
          isUsingLegacyProp = true;
        }
      } else if (this.props.onRenderControls) {
        controls = this.props.onRenderControls();
      } else if (this.props.navRight) {
        controls = this.props.navRight;
        isUsingLegacyProp = true;
      }

      if (controls) {
        if (controls.type && controls.type.displayName === PAGE_HEADER_CONTROL) {
          vettedControls = controls;
        } else if (controls.props && controls.props.children) {
          vettedControls = [];
          React.Children.forEach(controls.props.children, function (child) {
            if (child && child.type && child.type.displayName === PAGE_HEADER_CONTROL) {
              // eslint-disable-next-line fp/no-mutating-methods
              vettedControls.push(child);
            }
          });
        } // Backward compatibility for older 'contentRight' & 'navRight' structures.


        if (isUsingLegacyProp && (!vettedControls || vettedControls.length < 1)) {
          if (typeof controls !== 'string') {
            legacyControls = React.createElement("div", _extends({
              className: "slds-page-header__controls"
            }, controls.props));
          } else {
            legacyControls = React.createElement("div", {
              className: "slds-page-header__controls"
            }, controls);
          }
        }

        return React.createElement("div", {
          className: classnames("slds-page-header__col-".concat(this.props.type), this.props.className)
        }, legacyControls || React.createElement("div", {
          className: "slds-page-header__controls"
        }, vettedControls));
      }

      return null;
    }
  }]);

  return Controls;
}(Component);

Controls.displayName = displayName;
Controls.propTypes = propTypes;
Controls.defaultProps = defaultProps;
export default Controls;
//# sourceMappingURL=controls.js.map